
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[] = "@(#)80       1.15  src/oss/kazn/kail/kail_kernel.c, oss.kazn.src, oss600, 070720c 8/9/07 13:33:30";
#include <linux/kernel.h>

#include <linux/module.h>



#include <linux/moduleparam.h>


#include <linux/init.h>

#include <linux/types.h>

#include <linux/slab.h>

#include <linux/vmalloc.h>

#include <linux/smp_lock.h>

#include <linux/sched.h>

#include <linux/file.h>

#include <linux/fs.h>

#include <asm/atomic.h>

#include <asm/semaphore.h>

#include <asm/current.h>

#include <asm/uaccess.h>

int kazn_kernel_configured = 0;

MODULE_AUTHOR("IBM / Tivoli Systems");
MODULE_DESCRIPTION("IBM / Tivoli Access Manager for Operating Systems");

 MODULE_LICENSE("GPL");






#include <linux/vermagic.h>

#include <linux/compiler.h>
struct module __this_module
__attribute__((section(".gnu.linkonce.this_module"))) = {





 .name = __stringify(KBUILD_MODNAME),

 .init = init_module,



};



MODULE_VERSION("6.0");




static const char __module_depends[]
__attribute_used__
__attribute__((section(".modinfo"))) =
"depends=";

static long sys_call_table_addr = 0;
long *kail_sys_call_table = NULL;

module_param(sys_call_table_addr, long, 0);
int change_KailPerm2ro()
{
    printk("\nKAIL_KERNEL: dummy  KailPerm2ro\n");
   return 0;
}
static int change_KailPerm2rw()
{
    printk("\nKAIL_KERNEL: dummy  KailPerm2rw\n");
   return 0;
}







extern void kail_kernel_interface(void);
static int __init kail_init_module(void)
{
    int err = 0;

    ;



    if (current->security != NULL) {
        ;

        return -EPERM;
    }
    kail_kernel_interface();


    if (kazn_kernel_configured) {
            ;
            return 0;
    } else {
            kazn_kernel_configured = 1;
    }


    if (sys_call_table_addr) {
        kail_sys_call_table = (long *)(sys_call_table_addr);
        ;

    }
    else return -EINVAL;
     ;
     err = change_KailPerm2rw();




    ;

    return( err );

}






static void kail_cleanup_module(void)
{
    int err=0;

    ;

    if (!kazn_kernel_configured) {
        err = -1;
        printk( "KAIL_KERNEL is NOT currently configured!\n" );
    } else {
        kazn_kernel_configured = 0;
    }

    ;

    if (err) {
        err = 0;
        kazn_kernel_configured = 1;
        goto out;
    }

 out:

    return;
}


module_init(kail_init_module);
module_exit(kail_cleanup_module);
